"""
Node

All machines or network elements, or virtual machines, or any other thing that
is going to be provisioned, configured, monitored and repaired, needs a way
of being uniquely identified.

The Node Id is the way to uniquely identify a node.

This version of node will use the host name.

TODO(g): Allow easy and flexible user-override using blocks so users can define
    custom methods for identifying their hosts.
"""


import socket


def GetName():
  """Returns the local node name, which uniquely identifies this node.
  
  TODO(g): Allow easy and flexible user-override using blocks so users can define
      custom methods for identifying their hosts.
  """
  
  hostname = socket.getfqdn()
  
  return hostname


def GetNamePathReady():
  """Returns a version of the Node name which can be put into an OS path without
  messing up the path name.
  """
  node_id = GetName()
  
  #TODO(g): This is ghetto, replace
  replace_char = '_'
  replace_needed = '-+=\\|/[]{}()!@#$%^&*();:`~'
  
  # Cycle through all the chars in the string, and replace them
  for char in replace_needed:
    while char in node_id:
      node_id = node_id.replace(char, replace_char)
  
  return node_id


def GetId():
  """Returns a unique node id, which in an integer."""
  raise Exception('Not yet implemented.  Needs some sort of service database, \
                  even a YAML file would do, and then needs to raise an \
                  exception if a node name doesnt match any node ids, and then \
                  it can call an RPC call on a listed hostname, which would \
                  give it a node number, and it could update it\'s node database\
                  from the RPC call and have a list of it\'s fellow nodes.')

