#!/usr/bin/python

#Author: Geoff Howland
#Project: Red Eye Monitoring (REM)   http://redeyemon.sourceforge.net/
#Licensed under the MIT License:     http://en.wikipedia.org/wiki/MIT_License

"""
Print out a one-line version of the stack.
"""


import traceback
import os


def Mini(depth=0, start_back_offset=0):
  """Returns a miniaturized string of the stack, useful for debugging.
  
  Args:
    depth: int (optional), depth to look into stack
    start_back_offset: int (optional), depth to go back before reporting the
        stack, to avoid reporting the end of the stack, if it only the calling
        functions are useful.
  """
  depth += 2

  start_back = -1
  start_back -= start_back_offset

  stack = traceback.extract_stack()

  items = []

  for item in stack[len(stack)-depth:start_back]:
    msg = '%s:%s:%s' % (os.path.basename(item[0]), item[1], item[2])
    items.append(msg)

  return ' -> '.join(items)



if __name__ == '__main__':
  pass
  ##Test it
  #def a(arg):
  #  b(arg)
  #
  #def b(arg):
  #  print Get(arg, 1)
  #
  #a(3)
